/* opt.c - Optimizer front end - Don Yang / Dave Newquist / John Rapp

   07/28/01
                                                                           */

#include<stdio.h>
#include"main.h"
#include"opt.h"
#include"tree.h"


/* Optimizers - easier to list them all here instead of creating a
   separate header file for each routine.                            */

extern int o_color(Node**);            /* (o_color.c) */
extern int o_duplicate(Node**);        /* (o_dup.c) */
extern int o_em(Node**);               /* (o_em.c) */
extern int o_empty(Node**);            /* (o_empty.c) */
extern int o_overlap(Node**);          /* (o_ovl.c) */
extern int o_pl_short(Node**);         /* (o_pl.c) */
extern int o_trivial_overlap(Node**);  /* (o_ovlt.c) */
extern int o_underscore(Node**);       /* (o_under.c) */
extern int o_whitespace(Node**);       /* (o_spc.c) */

/**************************************************************** Optimize */
void Optimize(Node **node)
{
   int modified;

   o_underscore(node);

   do
   {
      /* All these should be merged to one function instead of
         doing multiple passes, but it's easier to debug this way. */
      modified = 0;

      if( LimitBreak )  return;     modified |= o_empty(node);
      if( LimitBreak )  return;     modified |= o_duplicate(node);
      if( LimitBreak )  return;     modified |= o_color(node);
      if( LimitBreak )  return;     modified |= o_whitespace(node);
      if( LimitBreak )  return;     modified |= o_em(node);
      if( LimitBreak )  return;     modified |= o_trivial_overlap(node);
      if( LimitBreak )  return;     modified |= o_overlap(node);
      if( LimitBreak )  return;     modified |= o_pl_short(node);

   } while( modified );

} /* Optimize() */
