/* smlng.c - SML/NG states - Don Yang / Dave Newquist / John Rapp

   07/26/01
                                                                           */

#include<stdio.h>
#include"smlng.h"
#include"token.h"


/************************************************************ SetAttribute */
void SetAttribute(Attr *attr, Token *tag)
{
   if( tag == NULL )
      return;

   switch( tag->type )
   {
      case TagB:     attr->b = 1;   break;
      case TagI:     attr->i = 1;   break;
      case TagS:     attr->s = 1;   break;
      case TagTT:    attr->tt = 1;  break;
      case TagU:
         attr->u++;
         if( attr->u > MAX_U_LEVEL )
            attr->u = MAX_U_LEVEL;
         break;
      case TagEM:
         attr->em = !attr->em;
         break;
      case TagPL:
         attr->b = attr->i = attr->s = attr->em = attr->tt = attr->u = 0;
         break;

      case TagSize:
         attr->size = tag->lexeme.i;
         break;
      case TagColor:
         attr->color = tag->lexeme.i;
         break;

      default:
         break;
   }

} /* SetAttribute() */

/***************************************************** SetDefaultAttribute */
void SetDefaultAttribute(Attr *attr)
{
   attr->b = attr->em = attr->i = attr->s = attr->tt = attr->u = 0;
   attr->size = attr->color = -1;

} /* SetDefaultAttribute() */
