/* token.h

   07/26/01
                                                                           */

#ifndef TOKEN_H__
#define TOKEN_H__


#define INPUT_BUFFER_SIZE     0x4000

typedef enum
{
   TokenText, TokenSpace, TokenEOF,

   TagB, TagEM, TagI, TagPL, TagS, TagTT, TagU,
   TagSize, TagColor,

   TagOpen, TagClose

} TokenType;

typedef struct
{
   FILE *file;
   char buffer[INPUT_BUFFER_SIZE];
   int index, bufsize;

} Input;

typedef struct
{
   TokenType type;
   int tagtype;
   union
   {
      char *s;
      int i;
   } lexeme;

} Token;

void DeleteInput(Input *input);
void DeleteToken(Token *token);
Token *GetToken(Input *input);
Input *InitInput(FILE *file);


#endif
